
#include <mega16.h>
#include <delay.h>
#include <alcd.h>
#include <stdio.h>       // sprintf     stdio   //

#define ADC_VREF_TYPE ((0<<REFS1) | (0<<REFS0) | (0<<ADLAR))    //        adc   7   16    //
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | ADC_VREF_TYPE;
delay_us(10);
ADCSRA|=(1<<ADSC);
while ((ADCSRA & (1<<ADIF))==0);
ADCSRA|=(1<<ADIF);
return ADCW;
}

void main(void)
{
int     a=0 ;              //   adc       int     //
float   Temperature ;      //       float     //
char    Buffer_LCD[16];    // ǘ   lcd          ǘ      char     //

DDRA=(0<<DDA7) | (0<<DDA6) | (0<<DDA5) | (0<<DDA4) | (0<<DDA3) | (0<<DDA2) | (0<<DDA1) | (0<<DDA0);
PORTA=(0<<PORTA7) | (0<<PORTA6) | (0<<PORTA5) | (0<<PORTA4) | (0<<PORTA3) | (0<<PORTA2) | (0<<PORTA1) | (0<<PORTA0);
 
DDRD=(1<<DDD7) | (1<<DDD6) | (1<<DDD5) | (1<<DDD4) | (1<<DDD3) | (1<<DDD2) | (1<<DDD1) | (1<<DDD0);
PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (0<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);

ADMUX=ADC_VREF_TYPE;        //               adc   30  32    //
ADCSRA=(1<<ADEN) | (0<<ADSC) | (0<<ADATE) | (0<<ADIF) | (0<<ADIE) | (0<<ADPS2) | (1<<ADPS1) | (0<<ADPS0);
SFIOR=(0<<ADTS2) | (0<<ADTS1) | (0<<ADTS0);

lcd_init(16);    //(LCD  ) LCD   //
lcd_clear();    // LCD ǘ  //

while (1)
      { 
      a=read_adc(0);              // a    0  1023     ǎ            //
      Temperature=(a/2.054) ;    //       ADC    LM35       //                           
      sprintf(Buffer_LCD,"T=%3.1f",Temperature);  // LCD    Buffer_LCD        ǘ      //
      lcd_gotoxy(0,0);        //    0   0 //
      lcd_puts(Buffer_LCD);   //    Buffer_LCD       ǘ   //
      lcd_gotoxy(7,0);       //    7   0 //
      lcd_putsf("C");       //        LCD  C  ǘ //
      lcd_gotoxy(2,1);     //    2   1 //
      lcd_putsf("Electronic");    // LCD  Electronic   //
      delay_ms(500);            /*     500    0.5 */      
      }
}
